'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /*! ========================================================================
                                                                                                                                                                                                                   * Bootstrap Toggle: bootstrap2-toggle.js v2.2.0
                                                                                                                                                                                                                   * http://www.bootstraptoggle.com
                                                                                                                                                                                                                   * ========================================================================
                                                                                                                                                                                                                   * Copyright 2014 Min Hur, The New York Times Company
                                                                                                                                                                                                                   * Licensed under MIT
                                                                                                                                                                                                                   * ======================================================================== */

//TODO
//workout copyright and author and licence
//click handler
//publishing npm
//getting this as a global import

//import styles from '../css/bootstrap-toggle.css!';
var styles = {
  'toggle': 'toggle',
  'toggle-group': 'toggle-group',
  'off': 'off',
  'toggle-on': 'toggle-on',
  'toggle-off': 'toggle-off',
  'toggle-handle': 'toggle-handle'
};

// hack assume jquery available globally on the window object
var $ = window.$;

var getChanged = function getChanged(oldObj, newObj) {
  for (var _len = arguments.length, props = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    props[_key - 2] = arguments[_key];
  }

  return _lodash2.default.transform(props, function (result, prop) {
    if (oldObj[prop] !== newObj[prop]) {
      result[prop] = newObj[prop];
    }
  }, {});
};

//NOTE $element is the checkbox $toggle is the containing div
exports.default = _react2.default.createClass({
  displayName: 'bootstrap-toggle',

  getDefaultProps: function getDefaultProps() {
    return {
      on: 'On',
      off: 'Off',
      onstyle: 'primary',
      offstyle: 'default',
      size: 'normal',
      additionalClass: '',
      styleWrapper: {},
      width: null,
      height: null,
      checked: true,
      disabled: false,
      lineHeight: null
    };
  },

  handleClick: function handleClick() {
    this.setState({
      checked: !this.state.checked
    });
    if (this.props.handler) {
      var _props;

      (_props = this.props).handler.apply(_props, arguments);
    }
  },

  getInitialState: function getInitialState() {
    return {
      checked: this.props.checked
    };
  },

  calculateSizing: function calculateSizing() {
    var tgOn = $(this.refs.toggleOn);
    var tgOff = $(this.refs.toggleOff);
    if (!this.state.width) {
      this.setState({
        width: Math.round(Math.max(tgOn.outerWidth(), tgOff.outerWidth()) + $(this.refs.toggleHandle).outerWidth() / 2)
      });
    }
    if (!this.state.height) {
      this.setState({
        height: Math.max(tgOn.outerHeight(), tgOff.outerHeight())
      });
    }
    if (this.props.height && !this.state.lineHeight) {
      this.setState({
        lineHeight: this.props.height - (tgOn.outerHeight() - tgOn.height())
      });
    }
  },
  componentDidMount: function componentDidMount() {
    this.calculateSizing();
  },
  componentDidUpdate: function componentDidUpdate() {
    this.calculateSizing();
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    var state = getChanged(this.props, nextProps, 'height', 'width');
    _lodash2.default.assign(state, getChanged(this.state, nextProps, 'checked'));
    if (!nextProps.height || state.height) {
      state.lineHeight = null;
    }
    this.setState(state);
  },
  render: function render() {
    var _classNames, _classNames2, _classNames3, _classNames4;

    var width = this.props.width || this.state.width;
    var height = this.props.height || this.state.height;
    var lineHeight = this.props.height && this.state.lineHeight;
    var toggle_styles = {};
    var toggle_on_off_styles = {};

    if (width) {
      toggle_styles.width = width;
    }

    if (height) {
      toggle_styles.height = height;
      if (lineHeight) {
        toggle_on_off_styles.lineHeight = lineHeight + 'px';
      }
    }

    var baseObj = {
      btn: true,
      'btn-lg': this.props.size === 'large',
      'btn-sm': this.props.size === 'small',
      'btn-xs': this.props.size === 'mini'
    };
    var onOffObj = null;
    if (this.state.checked) {
      onOffObj = _defineProperty({}, 'btn-' + this.props.onstyle, true);
    } else {
      onOffObj = _defineProperty({}, 'btn-' + this.props.offstyle, true);
    }
    var wrapperClass = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, styles.toggle, true), _defineProperty(_classNames, this.props.additionalClass, true), _defineProperty(_classNames, styles.off, !this.state.checked), _classNames), baseObj, onOffObj);

    var labelOnClass = (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, 'btn-' + this.props.onstyle, true), _defineProperty(_classNames2, styles['toggle-on'], width && height), _classNames2), baseObj);

    var labelOffClass = (0, _classnames2.default)((_classNames3 = {}, _defineProperty(_classNames3, 'btn-' + this.props.offstyle, true), _defineProperty(_classNames3, 'active', true), _defineProperty(_classNames3, styles['toggle-off'], width && height), _classNames3), baseObj);

    var spanClass = (0, _classnames2.default)((_classNames4 = {}, _defineProperty(_classNames4, styles['toggle-handle'], true), _defineProperty(_classNames4, 'btn-default', true), _classNames4), baseObj);

    var toggle_on_styles = {};
    var toggle_off_styles = {};
    var toggle_handle_styles = {};
    var toggle_group_styles = this.props.groupStyle || {};

    _lodash2.default.assign(toggle_styles, this.props.style);
    _lodash2.default.assign(toggle_on_styles, this.props.onHandleStyle, toggle_on_off_styles);
    _lodash2.default.assign(toggle_off_styles, this.props.offHandleStyle, toggle_on_off_styles);
    _lodash2.default.assign(toggle_handle_styles, this.props.handleStyle);

    return _react2.default.createElement(
      'div',
      { className: wrapperClass,
        disabled: this.props.disabled, onClick: this.handleClick, style: toggle_styles },
      _react2.default.createElement(
        'div',
        { className: styles['toggle-group'], style: toggle_group_styles },
        _react2.default.createElement(
          'label',
          { ref: 'toggleOn', className: labelOnClass, style: toggle_on_styles },
          this.props.on
        ),
        _react2.default.createElement(
          'label',
          { ref: 'toggleOff', className: labelOffClass, style: toggle_off_styles },
          this.props.off
        ),
        _react2.default.createElement('span', { ref: 'toggleHandle', className: spanClass, style: toggle_handle_styles })
      )
    );
  }
});
