/* */ 
'use strict';
var LIBRARY = require('./$.library'),
    $def = require('./$.def'),
    $redef = require('./$.redef'),
    hide = require('./$.hide'),
    has = require('./$.has'),
    SYMBOL_ITERATOR = require('./$.wks')('iterator'),
    Iterators = require('./$.iterators'),
    $iterCreate = require('./$.iter-create'),
    setToStringTag = require('./$.set-to-string-tag'),
    getProto = require('./$').getProto,
    BUGGY = !([].keys && 'next' in [].keys()),
    FF_ITERATOR = '@@iterator',
    KEYS = 'keys',
    VALUES = 'values';
var returnThis = function() {
  return this;
};
module.exports = function(Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCE) {
  $iterCreate(Constructor, NAME, next);
  var getMethod = function(kind) {
    if (!BUGGY && kind in proto)
      return proto[kind];
    switch (kind) {
      case KEYS:
        return function keys() {
          return new Constructor(this, kind);
        };
      case VALUES:
        return function values() {
          return new Constructor(this, kind);
        };
    }
    return function entries() {
      return new Constructor(this, kind);
    };
  };
  var TAG = NAME + ' Iterator',
      proto = Base.prototype,
      _native = proto[SYMBOL_ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT],
      _default = _native || getMethod(DEFAULT),
      methods,
      key;
  if (_native) {
    var IteratorPrototype = getProto(_default.call(new Base));
    setToStringTag(IteratorPrototype, TAG, true);
    if (!LIBRARY && has(proto, FF_ITERATOR))
      hide(IteratorPrototype, SYMBOL_ITERATOR, returnThis);
  }
  if ((!LIBRARY || FORCE) && (BUGGY || !(SYMBOL_ITERATOR in proto))) {
    hide(proto, SYMBOL_ITERATOR, _default);
  }
  Iterators[NAME] = _default;
  Iterators[TAG] = returnThis;
  if (DEFAULT) {
    methods = {
      values: DEFAULT == VALUES ? _default : getMethod(VALUES),
      keys: IS_SET ? _default : getMethod(KEYS),
      entries: DEFAULT != VALUES ? _default : getMethod('entries')
    };
    if (FORCE)
      for (key in methods) {
        if (!(key in proto))
          $redef(proto, key, methods[key]);
      }
    else
      $def($def.P + $def.F * BUGGY, NAME, methods);
  }
  return methods;
};
